
from scipy import *
from pylab import *

Frac  = 0
#worry about endpoints getting wrong value!
def diffuse_periodic(p, frac=Frac):
    p0 = p[0]
    p1 = p[1]
    pm1 = p[-1]
    pm2 = p[-2]
    p[1:-1] =  (1-frac)*p[1:-1] + 0.5*frac*(p[0:-2] + p[2:])
    p[0] = (1-frac)*p0 + 0.5*frac*(pm1 + p1)
    p[-1] = (1-frac)*pm1 + 0.5*frac*(pm2 + p0)
    return


nx = 128
dt = 0.001
a=150
b = 100
Du = 10.0
Dv = 500.0
c=1.5
gamma = 0.5




dims = (nx)

x = arange(0,nx)
k = 4*2*pi/nx
u = 38.*ones(dims,dtype=float)
v = 25.*ones(dims,dtype=float)
#u += standard_normal(dims)
#v += standard_normal(dims)
u += cos(k*x)
v += cos(k*x)


ion()
for k in range(400000):

   diffuse_periodic(u,frac=dt*Du);
   diffuse_periodic(v,frac=dt*Dv);
#   print v[0:65:16]
#   sys.exit()

   h = 13.0*u*v/(1+u*(1+0.05*u))

   u +=  dt*((a-u) -h)*gamma
   v += dt*(c*(b-v)-h)*gamma
   if (k%100 == 0): 
        cla()
        plot(x,u,x,v)
	draw()

print "done"
show()


